untyped
global function primrosePrecache
global function OnWeaponPrimaryAttack_weapon_primrose
global function OnProjectileCollision_weapon_primrose
global function OnWeaponReload_weapon_primrose

void function primrosePrecache(){
    #if CLIENT
    thread primroseInit()
	PrecacheParticleSystem($"wpn_mflash_snp_hmn_smoke_side_FP")
	PrecacheParticleSystem($"wpn_mflash_snp_hmn_smoke_side")
    PrecacheParticleSystem($"P_projectile_lstar")
	PrecacheParticleSystem($"P_doubletake_proj")
    PrecacheParticleSystem($"P_xo_armor_impact")
	PrecacheParticleSystem($"P_muz_TPA")
	PrecacheParticleSystem($"titan_particle_accelerator")
    #endif
}

#if CLIENT
void function wormholeSwitch(var button){
    isA6K = !isA6K
}

var wormholeConst = null
var indicator = null
var flyout = null
bool isA6K = false
bool hasBlue = true
bool hasRed = false

void function primroseInit(){
    WaitFrame()
    RegisterButtonPressedCallback(KEY_Z, wormholeSwitch)
    wormholeConst = RuiCreate($"ui/cockpit_console_text_top_left.rpak", clGlobal.topoCockpitHudPermanent, RUI_DRAW_COCKPIT, -1)
	RuiSetInt(wormholeConst, "maxLines", 1)
	RuiSetInt(wormholeConst, "lineNum", 1)
	RuiSetFloat2(wormholeConst, "msgPos", <0.82, 0.35, 0.0>)
	RuiSetString(wormholeConst, "msgText", "Wormhole:")
	RuiSetFloat(wormholeConst, "msgFontSize", 42.0)
	RuiSetFloat(wormholeConst, "msgAlpha", 0.0)
	RuiSetFloat(wormholeConst, "thicken", 0.0)
	RuiSetFloat3(wormholeConst, "msgColor", <1.0, 0.55, 0.0>)
	indicator = RuiCreate($"ui/cockpit_console_text_top_left.rpak", clGlobal.topoCockpitHudPermanent, RUI_DRAW_COCKPIT, -1)
	RuiSetInt(indicator, "maxLines", 1)
	RuiSetInt(indicator, "lineNum", 1)
	RuiSetFloat2(indicator, "msgPos", <0.9245, 0.35, 0.0>)
	RuiSetString(indicator, "msgText", "Base")
	RuiSetFloat(indicator, "msgFontSize", 42.0)
	RuiSetFloat(indicator, "msgAlpha", 0.0)
	RuiSetFloat(indicator, "thicken", 0.0)
	RuiSetFloat3(indicator, "msgColor", <0.1, 0.4, 1.0>)
    thread primroseMain()
}

void function primroseMain(){
    for(;;){
        WaitFrame()
        entity player = GetLocalViewPlayer()
		if (player == null || !IsValid(player))
			continue
        entity weapon = player.GetActiveWeapon()
        if (!IsValid(weapon))
			continue
        if(weapon.GetWeaponClassName() == "mp_weapon_sniper"){
            entity viewModel = player.GetViewModelEntity()
            RuiSetFloat(indicator, "msgAlpha", 0.9)
            RuiSetFloat(wormholeConst, "msgAlpha", 0.9)
            if(!isA6K && !hasBlue){
				RuiSetFloat3(indicator, "msgColor", <0.1, 0.4, 1.0>)
                RuiSetString(indicator, "msgText", "Base")
                weapon.EmitWeaponSound_1p3p("weapon_coldwar_chargeup_1p", "")
		        weapon.EmitWeaponSound_1p3p("weapon_smartpistol_slideback", "")
                flyout = null
	        	flyout = CreateCockpitRui($"ui/weapon_flyout.rpak")
		        RuiSetGameTime(flyout, "startTime", Time())
        		RuiSetFloat(flyout, "duration", 3.0)
        		RuiSetBool(flyout, "showWeaponXP", false)
        		RuiSetFloat3(flyout, "color", <0.1, 0.4, 1.0>)
        		RuiSetString(flyout, "titleText", "`2Baseline Reality`0")
                RuiSetString(flyout, "descriptionText", "Baseline matter is ionised and propelled.")
        		RuiSetFloat(flyout, "underlineHeight", 4.0)
	        	RuiSetFloat(flyout, "underlineWidth", 4.0)
	        	RuiTrackFloat3(flyout, "pos", viewModel, RUI_TRACK_POINT_FOLLOW, viewModel.LookupAttachment("flyout"))
                hasBlue = true
                hasRed = false
            }
            if(isA6K && !hasRed){
				RuiSetFloat3(indicator, "msgColor", <1.0, 0.1, 0.1>)
                RuiSetString(indicator, "msgText", "A6K")
                weapon.EmitWeaponSound_1p3p("weapon_coldwar_chargeup_1p", "")
		        weapon.EmitWeaponSound_1p3p("weapon_smartpistol_slideback", "")
                flyout = null
		        flyout = CreateCockpitRui($"ui/weapon_flyout.rpak")
		        RuiSetGameTime(flyout, "startTime", Time())
		        RuiSetFloat(flyout, "duration", 3.0)
		        RuiSetBool(flyout, "showWeaponXP", false)
		        RuiSetFloat3(flyout, "color", <1.0, 0.1, 0.1>)
		        RuiSetString(flyout, "titleText", "`2A6K 'Parallel' Dimension`0")
		        RuiSetString(flyout, "descriptionText", "A6K's particles are transferred and accelerated.")
		        RuiSetFloat(flyout, "underlineHeight", 4.0)
		        RuiSetFloat(flyout, "underlineWidth", 4.0)
		        RuiTrackFloat3(flyout, "pos", viewModel, RUI_TRACK_POINT_FOLLOW, viewModel.LookupAttachment("flyout"))
                hasBlue = false
                hasRed = true
            }
        }
        else{
            RuiSetFloat(indicator, "msgAlpha", 0.0)
            RuiSetFloat(wormholeConst, "msgAlpha", 0.0)
        }
    }
}
#endif

var function OnWeaponPrimaryAttack_weapon_primrose(entity weapon, WeaponPrimaryAttackParams attackParams)
{
	weapon.EmitWeaponNpcSound( LOUD_WEAPON_AI_SOUND_RADIUS_MP, 0.2 )
	#if CLIENT
		if(!isA6K){
			weapon.EmitWeaponSound_1p3p("Weapon_HemlokSMG_Single_1P", "")
			weapon.EmitWeaponSound_1p3p("weapon_kraber_fire_1p", "")
			weapon.EmitWeaponSound_1p3p("weapon_batterygun_firestart_1p", "")
			weapon.PlayWeaponEffect($"wpn_muzzleflash_xo_elec_FP", $"", "muzzle_flash")
		}
		else{
			weapon.EmitWeaponSound_1p3p("weapon_titan_sniper_level_1_1p", "")
			weapon.EmitWeaponSound_1p3p("weapon_g2a4_fire_1p", "")
			weapon.PlayWeaponEffect( $"P_muz_lstar_FP", $"", "muzzle_flash" )
		}
	#endif
	return FireWeaponPlayerAndNPC( weapon, attackParams, true )
}

int function FireWeaponPlayerAndNPC( entity weapon, WeaponPrimaryAttackParams attackParams, bool playerFired )
{
	bool shouldCreateProjectile = false
	if(IsServer() || weapon.ShouldPredictProjectiles())
		shouldCreateProjectile = true

	#if CLIENT
		if(!playerFired)
			shouldCreateProjectile = false
	#endif

	if (shouldCreateProjectile){
		int boltSpeed = expect int( weapon.GetWeaponInfoFileKeyField( "bolt_speed" ) )
		int damageFlags = weapon.GetWeaponDamageFlags()
		entity bolt = weapon.FireWeaponBolt( attackParams.pos, attackParams.dir, boltSpeed, damageFlags, damageFlags, playerFired, 0 )
		if ( bolt != null ){
			bolt.kv.gravity = expect float( weapon.GetWeaponInfoFileKeyField( "bolt_gravity_amount" ) )
			StartParticleEffectOnEntity(bolt, GetParticleSystemIndex($"weapon_kraber_projectile"), FX_PATTACH_ABSORIGIN_FOLLOW, -1)
			#if CLIENT
			StartParticleEffectOnEntity(bolt, GetParticleSystemIndex($"P_titan_sniper1"), FX_PATTACH_ABSORIGIN_FOLLOW, -1)
			if(!isA6K){
				StartParticleEffectOnEntity(bolt, GetParticleSystemIndex($"wpn_grenade_frag_blue"), FX_PATTACH_ABSORIGIN_FOLLOW, -1)
				StartParticleEffectOnEntity(bolt, GetParticleSystemIndex($"P_doubletake_proj"), FX_PATTACH_ABSORIGIN_FOLLOW, -1)
				StartParticleEffectOnEntity(bolt, GetParticleSystemIndex($"P_wpn_mflash_dbltake_FP_burn"), FX_PATTACH_ABSORIGIN_FOLLOW, -1)
			}
			else{
				StartParticleEffectOnEntity(bolt, GetParticleSystemIndex($"P_proj_predator_alt_pwr"), FX_PATTACH_ABSORIGIN_FOLLOW, -1)
				StartParticleEffectOnEntity(bolt, GetParticleSystemIndex($"P_projectile_lstar"), FX_PATTACH_ABSORIGIN_FOLLOW, -1)
			}
			#endif
		}
	}

	return 1
}

void function OnProjectileCollision_weapon_primrose(entity projectile, vector pos, vector normal, entity hitEnt, int hitbox, bool isCritical){
	#if CLIENT
	if(!isA6K){
		StartParticleEffectInWorld( GetParticleSystemIndex( $"wpn_muzzleflash_arc_cannon_fp" ), pos, -normal )
		StartParticleEffectInWorld( GetParticleSystemIndex( $"impact_arc_cannon_titan" ), pos, -normal + <90, 0, 0> )
		StartParticleEffectInWorld( GetParticleSystemIndex( $"P_xo_armor_impact" ), pos, -normal )
	}
	else{
		StartParticleEffectInWorld(GetParticleSystemIndex($"P_muz_TPA"), pos, -normal)
		StartParticleEffectInWorld(GetParticleSystemIndex($"titan_particle_accelerator"), pos, -normal)
	}
	#endif
	#if SERVER
		int bounceCount = projectile.GetProjectileWeaponSettingInt( eWeaponVar.projectile_ricochet_max_count )
		if ( projectile.proj.projectileBounceCount >= bounceCount )
			return

		if ( hitEnt == svGlobal.worldspawn )
			EmitSoundAtPosition( TEAM_UNASSIGNED, pos, "Bullets.DefaultNearmiss" )

		projectile.proj.projectileBounceCount++
	#endif
}

void function OnWeaponReload_weapon_primrose(entity weapon, int milestoneIndex){
	#if CLIENT
	weapon.PlayWeaponEffect($"P_emp_body_human", $"", "shell")
	weapon.PlayWeaponEffect($"P_wpn_charge_coldwar_FP", $"", "shell")
	weapon.PlayWeaponEffect($"wpn_muzzleflash_arc_cannon_fp", $"", "muzzle_flash")
	weapon.PlayWeaponEffect($"P_doubletake_proj", $"", "muzzle_flash")
	weapon.PlayWeaponEffect($"xo_spark_med", $"", "shell")
	weapon.PlayWeaponEffect($"xo_spark_med", $"", "muzzle_flash")
	weapon.PlayWeaponEffect($"P_wpn_mflash_arcball", $"", "muzzle_flash")
	weapon.PlayWeaponEffect($"P_wpn_mflash_arcball", $"", "shell")
	weapon.EmitWeaponSound_1p3p("LSTAR_LensBurnout", "")
	weapon.EmitWeaponSound_1p3p("LSTAR_VentCooldown", "")
	weapon.EmitWeaponSound_1p3p("Weapon_Titan_Sniper_SustainLoop", "")
	weapon.EmitWeaponSound_1p3p("wpn_Thunderbolt_ADS_In_1P", "")
	weapon.EmitWeaponSound_1p3p("wpn_Thunderbolt_ADS_Out_1P", "")
	if(weapon.HasMod("pas_fast_reload"))
		thread DelayedStopEffect1(weapon, 1.0)
	else
		thread DelayedStopEffect1(weapon, 1.5)
	#endif

}

void function DelayedStopEffect1(entity weapon, float delayTime1){
	#if CLIENT
	Wait(delayTime1)
	if(IsValid(weapon)){
		weapon.StopWeaponEffect($"P_emp_body_human", $"")
		weapon.StopWeaponEffect($"P_wpn_charge_coldwar_FP", $"")
		weapon.StopWeaponEffect($"P_doubletake_proj", $"")
		FadeOutSoundOnEntity(weapon, "Weapon_Titan_Sniper_SustainLoop", 0.5)
	}
	#endif
}